var compassSettings = new SettingsObject("Compass", [
    {
        name: "Compass",
        settings: [
            new Setting.Toggle("Toggled", true),
            new Setting.Slider("Width", 150, 50, 500)
        ]
    }
])

compassSettings.setCommand("compass")
Setting.register(compassSettings)

var compass = {
    update: function() {
        this.toggled = compassSettings.getSetting("Compass", "Toggled")
        this.width = compassSettings.getSetting("Compass", "Width")
        this.half = this.width / 2
        this.middle = Renderer.screen.getWidth() / 2
    },
    direction: new Text("", 0, 0)
}

register("renderOverlay", function() {
    compass.update()
    if (!compass.toggled) return
    
    Renderer.drawRect(0x50000000, compass.middle - compass.half, 0,compass.width, 20)

    for (var i = 0; i < 360; i += 5) {
        x = compass.middle - Player.getYaw() + i

        if (x < compass.middle - compass.half) {
            x += 360
        } else if (x > compass.middle + compass.half) {
            x -= 360
        }

        alpha = 255
        if (x < compass.middle - compass.half + 10) {
            alpha = MathLib.map(x,
                compass.middle - compass.half,
                compass.middle - compass.half + 10,
                0, 255
            )
        } else if (x > compass.middle + compass.half - 10) {
            alpha = MathLib.map(x,
                compass.middle + compass.half,
                compass.middle + compass.half - 10,
                0, 255
            )
        }

        height = 5
        color = Renderer.color(255, 255, 255, alpha)
        if (i % 90 == 0) {
            color = Renderer.color(255, 0, 0, alpha)
            height = 9
            if (i == 0) {
                compass.direction.setString("S")
            } else if (i == 90) {
                compass.direction.setString("W")
            } else if (i == 180) {
                compass.direction.setString("N")
            } else if (i == 270) {
                compass.direction.setString("E")
            }
            compass.direction.setColor(Renderer.color(255, 255, 255, alpha)).draw(x - 2, 11)
        } else if (i % 15 == 0) {
            height = 7
        }

        Renderer.drawRect(
            color,
            x, 0, 1, height
        )
    }
})